# clase viejo estilo
class Vieja():
    def __init__(self, var1):
        self._var1 = var1
        print "clase vieja:", var1

# clase nuevo estilo
class Nueva(object):
    def __init__(self, var1):
        self._var1 = var1
        print "clase nueva:", var1

AutoInteractiveShell.clear()

# herencia
class A(object):
    def __init__(self, a):
        self.a = a

class B(object):
    def __init__(self, b):
        self.b = b

class C(A, B):
    def __init__(self, a, b):
        A.__init__(self, a)
        B.__init__(self, b)
        print self.a
        print self.b

a = C("a", "b")

AutoInteractiveShell.clear()

# metodos estaticos y de clase
class Clase(object):

    classvar = "de clase"

    def __init__(self, a, b):
        self._a = a
        self._b = b

    @classmethod
    def declase(cls):
        print cls.classvar

    @staticmethod
    def estatico():
        print "static"

c = Clase('a', 'b')

Clase.estatico()
c.estatico()

Clase.declase()
c.declase()

AutoInteractiveShell.clear()

# name mangling
class Clase(object):
    def __init__(self, a, b):
        self._a = a
        self._b = b
        self.__private_var = "pvar"
    def __private_method(self):
        print "private"
    def _protected(self):
        print "protected"

c = Clase("a", "b")

class Derivada(Clase):
    def __init__(self, a, b):
        # Clase.__init__(self, a, b)
        super(Derivada, self).__init__(a, b)

d = Derivada("da", "dv")

c
d

AutoInteractiveShell.clear()

