AutoInteractiveShell.clear()

# definamos algunas variables
secuencia = ['p', 'a', 'l', 'a', 'b', 'r', 'a']
frase = "GNU/Linux"
tupla = (4, 2, 1, 6, 7, 8)
conjunto = set([5, 2, 4, 1])
AutoInteractiveShell.clear() #limpio la pantalla

# Uniendo una secuencia
secuencia
"".join(secuencia) # une la secuencia
",".join(secuencia) # alguien dijo CSV?
frase
" ".join(frase) # se puede hacer con strings también
AutoInteractiveShell.clear()

# Slicing!
secuencia
secuencia[0:2] # los 2 primeros elementos
secuencia[3:] # desde el 4 elemento en adelante
secuencia[:4] # los primeros 4 elementos
secuencia[:-1] # todos los elementos menos el último
secuencia[-6:-1] # los negativos funcionan para los 2 límites
frase
frase[0:3] # esto funciona con los strings también
AutoInteractiveShell.clear()

# comprensión de listas
# armemos una copia de secuencia pero reemplazemos las a por o
secuencia
[letra.replace('a', 'o') for letra in secuencia]
# armemos una lista con solo los numeros pares contenidos en tupla
tupla
[numero for numero in tupla if not numero & 1]
AutoInteractiveShell.clear()

# ordenar una lista es simple
secuencia
secuencia.sort()
secuencia
AutoInteractiveShell.clear()

# casting (crear una copia del objeto pero con otro tipo de dato)
# list(obj) convierte obj a list (lista): obj tiene que ser iterable
# tuple(obj) convierte obj a tuple (tupla): obj tiene que ser iterable
# dict(obj) convierte obj a dict (diccionario): obj tiene que ser iterable
# str(obj) convierte obj a string (cadena de caracteres)
# int(obj) convierte obj a int (entero): obj puede ser un float o un string que contiene un numero entero decimal
# float(obj) convierte obj a float (flotante): obj puede ser un int  o un string que contiene un numero decimal
# complex(obj) convierte obj a complex (complejo): obj puede ser int o float o un string con un numero complejo
# concatenemos secuencia con tupla
secuencia + tupla # lanza un error
secuencia + list(tupla) # funciona por el cast
tupla # tupla sigue siendo una tupla, el cast sólo ha creado una lista con contenido similar
frase # ahora vamos a unir esto
secuencia # con esto
list(frase) + secuencia # list convierte la cadena en una lista de caracteres!
AutoInteractiveShell.clear()

# Jugando con strings
frase + "".join(secuencia) # usamos el signo +
frase * 5 # repitamos frase 5 veces
'-'.join(frase) * 5 # repitamos frase 5 veces pero con separadores
frase.startswith("GNU") # la frase comienza con GNU?
frase.endswith("Linux") # la frase termina Linux?
frase.find("/") # a dónde está la barra?

AutoInteractiveShell.clear()
