# -*- coding: utf-8 -*-
# This file is part of ejercicio

# ejercicio is free software: you can redistribute it and/or modify
# it under the terms of the Python 2.6.2 license

# ejercicio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.

# To read the license please read:
# http://www.python.org/download/releases/2.6.2/license/

# Author: Fabian Ezequiel Gallina <fgallina at from-the-cloud dot com>
class Usuario(object):
    """Usuario"""

    def __init__(self, nombre, apellido, telefono):
        """
        Arguments:
        - `nombre`: nombre del usuario
        - `apellido`: apellido del usuario
        - `telefono`: telefono del usuario
        """
        self.nombre = nombre
        self.apellido = apellido
        self.telefono = telefono

    def mostrar(self):
        """Imprime los datos del usuario"""
        salida = "Nombre: " + self.nombre + "\n"
        salida += "Apellido: " + self.apellido + "\n"
        salida += "Teléfono: " + self.telefono + "\n"
        print salida

    def csv(self):
        """Retorna el objeto formateado como una linea CSV"""
        return self.nombre + "," + self.apellido + "," + self.telefono
